## guitarix 0.32.1

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8

import sys, os, re, shutil
import Build, Utils, Options, Logs, Configure, Scripting
from Constants import HEXVERSION
from Configure import ConfigurationError
from TaskGen import feature
import wscript_dsp

# Waf version check, for global waf installs

try:
    from Constants import WAFVERSION
except:
    WAFVERSION='1.0.0'
if WAFVERSION[:3] != '1.5':
    print('Incompatible Waf, use 1.5')
    sys.exit (1)

# these variables are mandatory ('/' are converted automatically)
srcdir = '.'
blddir = 'build'
use_2to3 = True

# used by waf dist and waf build
VERSION='0.32.1'
APPNAME='guitarix'

good_faust_versions = ['0.9.58','0.9.65']

g_maxlen = 40 # maximum width of message for 2-column display


################################################################
# options defined for waf configure
################################################################

def set_options(opt):
    
    def add_enable_option (option, desc, group=None, disable=False):
        if group == None:
            group = opt
        option_ = option.replace ('-', '_')
        group.add_option ('--enable-' + option, action='store_true',
            default=False, help='Enable ' + desc, dest='enable_' + option_)
        group.add_option ('--disable-' + option, action='store_true',
            default=disable, help='Disable ' + desc, dest='disable_' + option_)

    opt.tool_options('gcov')
    opt.tool_options ('intltool')
    group = opt.add_option_group ('Localization and documentation', '')
    add_enable_option ('nls', 'native language support', group)

    opt.tool_options('compiler_cxx')
    comp = opt.get_option_group("--check-cxx-compiler")

    comp.add_option('--debug',
                    action='store_const',
                    default=False,
                    const=True,
                    help='set compiler flags for a debug build')

    comp.add_option('--cxxflags-release',
                    type='string',
                    default='-O3 -DNDEBUG',
                    dest='cxxflags_release',
                    help='additional C++ compiler flags for release version (not used if --debug) [Default: %default]')

    comp.add_option('--cxxflags-debug',
                    type='string',
                    default='-O2 -g -fstack-protector-all',
                    dest='cxxflags_debug',
                    help='additional C++ compiler flags for debug version (only used if --debug) [Default: %default]')

    comp.add_option('--cxxflags',
                    type='string',
                    default='-Wall', # -fomit-frame-pointer -ffast-math -fstrength-reduce -mmmx -mfpmath=sse -DUSE_XMMINTRIN -pipe
                    dest='cxxflags',
                    help='C++ base compiler flags [Default: %default]')

    comp.add_option('--ldflags',
                    type='string',
                    default='', 
                    dest='ldflags',
                    help='C++ base linker flags ')

    comp.add_option('--optimization',
                    action='store_const',
                    default=False, #'-fomit-frame-pointer -ffast-math -fstrength-reduce -pipe',
                    const=True,
                    help='automatically select additional C++ compiler optimization flags for the current platform')

    comp.add_option('--no-desktop-update',
                    action='store_const',
                    default=False, #'-fomit-frame-pointer -ffast-math -fstrength-reduce -pipe',
                    const=True,
                    help='dont automatically update desktop database')


    opt.recurse('libgxw/gxw')
    opt.recurse('libgxwmm/gxwmm')

    comp = opt.add_option_group("Additional Library Options")

    comp.add_option('--includeresampler',
                    action='store_const',
                    default=False,
                    const=True,
                    help='build with included local zita-resample libary (Default NO)')

    comp.add_option('--includeconvolver',
                    action='store_const',
                    default=False,
                    const=True,
                    help='build with included local zita-convolver libary (Default NO)')

    comp.add_option('--convolver-ffmpeg',
                    action='store_const',
                    default=False,
                    const=True,
                    help='modified zita-convolver libary that uses ffmpeg instead of fftw3 for FFT (Default NO)')

    comp.add_option('--libdir',
                   type='string',
                   default='', 
                   dest='libdir',
                   help=('library install path '),
                   )

    faust = opt.add_option_group("Faust-Compiler")

    if len(good_faust_versions) == 1:
        faust_vers_str = good_faust_versions[0]
    else:
        faust_vers_str = "in [%s]" % ", ".join(good_faust_versions)

    faust.add_option('--faust',
                     action='store_const',
                     default=False,
                     const=True,
                     help=('use faust even if the installed version is not %s'
                           % faust_vers_str))

    faust.add_option('--no-faust',
                     action='store_const',
                     default=False,
                     const=True,
                     help="don't use faust, use the pre-built files in faust-generated")

    faust.add_option('--faust-float',
                     action='store_const',
                     default=False,
                     const=True,
                     help="build with faust, single precision")

    faust.add_option('--faust-vectorize',
                     action='store_const',
                     default=False,
                     const=True,
                     help="call faust with --vectorize")

    faust.add_option('--faust-vectorize-float',
                     action='store_const',
                     default=False,
                     const=True,
                     help=("call faust with --vectorize for sources built"
                           "in single (float) precision"))

    faust.add_option('--faust-options', help="additional faust options")

    ladspa = opt.add_option_group("LADSPA Options (installing ladspa modules)")

    ladspa.add_option('--no-ladspa',
                    action='store_const',
                    default=False,
                    const=True,
                    help="don't build ladspa plugins (Default yes)")

    ladspa.add_option('--no-new-ladspa',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("don't build with new ladspa plugins (Default yes)"))


    ladspa.add_option('--ladspadir',
                    type='string',
                    help='LADSPA plugin directory [Default: <prefix>/lib/ladspa]')

    lv2 = opt.add_option_group("LV2 Options (installing LV2 modules)")

    lv2.add_option('--lv2dir',
                    type='string',
                    help='LV2 plugin directory [Default: <prefix>/lib/lv2]')

    lv2.add_option('--no-lv2',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("don't build new lv2 plugins (Default no)"))

    lv2.add_option('--no-lv2-gui',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("don't build lv2 plugin GUI's (Default no)"))

    lv2.add_option('--lv2-only',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("build only the lv2 plugins (Default no)"))

    lv2.add_option('--disable-sse',
                    action='store_const',
                    default=False,
                    const=True,
                    help=("disable SSE for lv2 plugins (ARM)"))


    opt.recurse('pygxw')
    opt.recurse('glade-gxw')

    opt.tool_options('compiler_cc') # for pygxw and glade-gxw

    opt.add_option('--dist-tree',
                   type='string',
                   dest='dist_tree',
                   help=("option for 'dist' command: git tree-ish to build"
                         " the archive from [Default: %s]" % 'V%s' % VERSION))

    opt.sub_options('src/gx_head');


################################################################
# waf configure
################################################################

################################################################
# configuration display helper functions
#

def print_msg(msg, nl=True):
    if HEXVERSION > 0x10500:
        s = sys.stderr
    else:
        s = sys.stdout
    if nl:
        t = "\n"
    else:
        t = " "
    s.write(msg+t)

# a bit of waf display formatting
def display_msg(msg, status = None, color = None):
    sr = msg
    global g_maxlen
    g_maxlen = max(g_maxlen, len(msg))
    if status:
        print_msg("%s :" % msg.ljust(g_maxlen),False)
        Utils.pprint(color, status)
    else:
        print_msg("%s" % msg.ljust(g_maxlen))

def error_msg(msg):
    Utils.pprint('RED', msg)

def display_feature(msg, build):
    if build:
        display_msg(msg, "yes", 'CYAN')
    else:
        display_msg(msg, "no", 'YELLOW')

################################################################
# configuration utility functions
#

def option_enabled (option):
    if getattr (Options.options, 'enable_' + option):
        return True
    if getattr (Options.options, 'disable_' + option):
        return False
    return True

def append_optimization_flags(cxxflags):
    cpu_model = None
    x86_flags = None
    try:
        for line in open("/proc/cpuinfo"):
            if cpu_model is None:
                if line.startswith("model name"):
                    cpu_model = line.split(":",1)[1].strip()
            elif x86_flags is None:
                if line.startswith("flags"):
                    x86_flags = line.split(":",1)[1].strip()
            else:
                break
    except IOError:
        pass
    if cpu_model is None or x86_flags is None:
        display_msg("Checking CPU Architecture",
                    "cpu model not found in /proc/cpuinfo",
                    "YELLOW")
        return None
    model = cpu_model.split()
    arch = os.uname()[4]
    if "AMD" in model and "x86_64" in arch:
        cxxflags.append ("-march=k8")
    elif "AMD" in model and "Sempron(tm)" in model:
        cxxflags.append ("-march=native")
    elif "Geode" in model :
        cxxflags.append ("-march=geode")
    elif "Core" in model and "x86_64" in arch:
        cxxflags.append ("-march=core2")
    elif "i386" in arch:
        cxxflags.append ("-march=i386")
    elif "i486" in arch:
        cxxflags.append ("-march=i486")
    elif "i586" in arch:
        cxxflags.append ("-march=i586")
    elif "i686" in arch:
        cxxflags.append ("-march=i686")
    else:
        cxxflags.append ("-march=native")

    if "mmx" in x86_flags:
        cxxflags.append ("-mmmx")
    if "3dnow" in x86_flags:
        cxxflags.append ("-m3dnow")

    if "sse5" in x86_flags:
        cxxflags.append ("-msse5")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4_2" in x86_flags:
        cxxflags.append ("-msse4.2")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4_1" in x86_flags:
        cxxflags.append ("-msse4.1")
        cxxflags.append ("-mfpmath=sse")
    elif "ssse3" in x86_flags:
        cxxflags.append ("-mssse3")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4a" in x86_flags:
        cxxflags.append ("-msse4a")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4" in x86_flags:
        cxxflags.append ("-msse4")
        cxxflags.append ("-mfpmath=sse")
    elif "sse3" in x86_flags:
        cxxflags.append ("-msse3")
        cxxflags.append ("-mfpmath=sse")
    elif "sse2" in x86_flags:
        cxxflags.append ("-msse2")
        cxxflags.append ("-mfpmath=sse")

=== src/LV2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import os, re

def sub_file(src_fname, dst_fname, lst):

    f = open(src_fname, 'rU')
    txt = f.read()
    f.close()

    for (key, val) in lst:
        re_pat = re.compile(key, re.M)
        txt = re_pat.sub(val, txt)

    f = open(dst_fname, 'w')
    f.write(txt)
    f.close()

def append_sse_flags():
    cpu_model = None
    x86_flags = None
    try:
        for line in open("/proc/cpuinfo"):
            if cpu_model is None:
                if line.startswith("model name"):
                    cpu_model = line.split(":",1)[1].strip()
            elif x86_flags is None:
                if line.startswith("flags"):
                    x86_flags = line.split(":",1)[1].strip()
            else:
                break
    except IOError:
        pass
    if cpu_model is None or x86_flags is None:
        return False
    model = cpu_model.split()
    arch = os.uname()[4]

    if "sse2" in x86_flags:
        return True
    else:
        return False

def dirlist():
    subdirs = [
        'gx_amp.lv2',
        'gx_amp_stereo.lv2',
        'gxautowah.lv2',
        'gxbooster.lv2',
        'gx_chorus.lv2',
        'gx_compressor.lv2',
        'gx_delay.lv2',
        'gxechocat.lv2',
        'gx_echo.lv2',
        'gx_expander.lv2',
        'gx_flanger.lv2',
        'gxmetal_amp.lv2',
        'gxmetal_head.lv2',
        'gx_phaser.lv2',
        #'gxpreamp.lv2',
        #'gxpreamp.lv2/StereoAmp',
        'gx_redeye.lv2',
        'gx_reverb.lv2',
        'gx_studiopre.lv2',
        'gx_studiopre_st.lv2',
        'gxtilttone.lv2',
        'gx_tremolo.lv2',
        'gxts9.lv2',
        'gxtubedelay.lv2',
        'gxtubetremelo.lv2',
        'gxtubevibrato.lv2',
        'gxtuner.lv2',
        'gx_zita_rev1.lv2',
        'gx_mbdistortion.lv2',
        'gx_mbdelay.lv2',
        'gx_mbecho.lv2',
        'gx_mbcompressor.lv2',
        'gx_fuzz.lv2',
        'gx_graphiceq.lv2',
        'gx_duck_delay.lv2',
        'gx_duck_delay_st.lv2',
        'gx_barkgraphiceq.lv2',
        'gx_detune.lv2',
		'gx_shimmizita.lv2',
		'gx_switched_tremolo.lv2',
		'gx_room_simulator.lv2',
        'gx_digital_delay.lv2',
        'gx_digital_delay_st.lv2',
        'gx_livelooper.lv2',
        'gx_mbreverb.lv2',
         ]

    return subdirs

def configure(conf):
    if not conf.env['NOSSE']:
        conf.env['SSE2'] = append_sse_flags()
    pa = '.so'

    for x in dirlist():
        conf.sub_config('%s' % x);
        sub_file('./src/LV2/%s/manifest.ttl.in' % x, './src/LV2/%s/manifest.ttl' % x, (('@LIB_EXT@', '%s' % pa), ))

def build(bld):
    # faust folder keep out of dirlist
    bld.add_subdirs('faust')
    bld.add_subdirs(dirlist())
    
    if not bld.env['NOLV2GUI']:
        gx_ampstyledir = bld.path.find_dir( 'GUI' ) ;
        bld.install_files(bld.env['GX_LV2_STYLE_DIR'], gx_ampstyledir.ant_glob('**/*.png'),cwd=gx_ampstyledir, chmod=0o644, relative_trick=True)
        bld.install_files(bld.env['GX_LV2_STYLE_DIR'], gx_ampstyledir.ant_glob('**/*.rc'),cwd=gx_ampstyledir, chmod=0o644, relative_trick=True)

=== debian/changelog ===
guitarix (0.32.1-1build2) wily; urgency=medium

  * No-change rebuild against libjack-jackd2-0v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 11 Aug 2015 06:42:21 +0000

guitarix (0.32.1-1build1) wily; urgency=medium

  * No-change rebuild against libatkmm-1.6-1v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 07 Aug 2015 18:20:21 +0000

guitarix (0.32.1-1) unstable; urgency=medium

  * New upstream release
  * debian/control: Standards-Version: 3.9.6

 -- Roland Stigge <stigge@antcom.de>  Wed, 10 Dec 2014 14:09:11 +0100

=== debian/control ===
Source: guitarix
Section: sound
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Roland Stigge <stigge@antcom.de>
Build-Depends: debhelper (>= 9), python, libjack-dev, libsndfile1-dev, libgtk2.0-dev, ladspa-sdk, libzita-convolver-dev, libgtkmm-2.4-dev, libboost-dev (>= 1.53), libboost-thread-dev (>= 1.53), intltool, liblrdf0-dev, libboost-system-dev (>= 1.53), lv2-dev, libavahi-gobject-dev, libeigen3-dev, libzita-resampler-dev, libbluetooth-dev [linux-any], liblilv-dev
Standards-Version: 3.9.6
Homepage: http://guitarix.sourceforge.net/

Package: guitarix
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gtk2-engines, gtk2-engines-pixbuf
Recommends: jack-capture, vorbis-tools, lame
Description: Rock guitar amplifier for Jack
 Guitarix is a rock guitar amplifier for Jack (Jack Audio Connection Kit) with
 one input and two outputs. It is designed to get nice trash/metal/rock/guitar
 sounds.  Controls are available for bass, treble, gain, balance, distortion,
 freeverb, crybaby(wah) and echo. For the 'pressure' in the sound you can use
 the feedback and feedforward sliders. guitarix comes with a GTK interface and
 as Ladspa plugin.
